** Re-arrange the physical order of 
** form objects to match tab order

#DEFINE		DEFAULT_EXT ".SCX"

lpar p1form, p2label  && p1  FileSpec
**                    && p2  Sort labels as well

local work, TempFile, FormAlias, UniqParent, ;
	  SaveArea, SaveDecim, OnEscape, SetEscape, ;
      SaveTalk, i, j, n, temp, AnyDone, parent, ;
      FormsList, aList, aProcs, WhatFor, ;
      PathSpec, ParentFilt
dime  FormsList( 1 ), aList( 1 ), aProcs( 1 )
TempFile = UPPER(SYS(2015))

SetEscape = SET("ESCAPE")
OnEscape = ON("ESCAPE")
if empty( m.p1form )
	set escape off
	wait window "File spec required" Time 20
	set escape &SetEscape
	return
endif
on escape
set escape on

UniqParent = UPPER(SYS(2015))
SaveTalk = SET("TALK")
set talk off
SaveDecim = SET("DECIMAL")
set decimal to 0
SaveArea = select(0)

** save current SET PROC settings
priv SaveProc  && must not be local
SaveProc = SET("PROCEDURE")
temp = UPPER(FULL(SYS( 16 )))
i = RAT("\", m.temp)
if m.i > 0
	temp = LEFT(m.temp, m.i)
else
	temp = "\"
endif
set proc to (m.temp + "RFPROC")
Memo2Array(@m.aProcs, "m.SaveProc")

** make a list of forms from FileSpec
FormAlias = UPPER(SYS(2015))
temp = xTRIM( m.p1form )
i = 0
if not empty( m.temp )
	if RIGHT(m.temp, 1) = "\"
		temp = m.temp + DEFAULT_EXT
	else
		i = RAT("\", m.temp)
		if m.i > 0
			if RAT(".", SUBST(m.temp, m.i)) <= 0
				temp = m.temp + DEFAULT_EXT
			endif
		else
			if RAT(".", m.temp) <= 0
				temp = m.temp + DEFAULT_EXT
			endif
		endif
	endif
	temp = FULL( m.temp )
	PathSpec = RAT("\", m.temp)
	if m.PathSpec > 0
		PathSpec = LEFT(m.temp, PathSpec)
	else
		PathSpec = "\"
	endif
	i = ADIR(FormsList, m.temp)
endif
ASORT( FormsList )

work = UPPER(SYS(2015))
** Loop of forms
for i = 1 to m.i
	select 0
	use (m.PathSpec + FormsList(m.i, 1)) ;
		exclusive alias (m.FormAlias)
	wait window nowait FormsList(m.i, 1)

** Save in a Work table the first record and 
** the objects to be excluded from sort
	copy struc to (m.work)
	copy NEXT 1 to (m.TempFile)
	select 0
	use (m.work) exclusive
	append from (m.TempFile)
    WhatFor = ;
        "(empty( BaseClass ) or " + ;
        "(ATC('Environ', BaseClass)>0) or " + ;
        "(ATC('Form', BaseClass)>0) or " + ;
        "(ATC('Page', BaseClass)>0) or " + ;
        "(ATC('Timer', BaseClass)>0))"
	select( m.FormAlias )
	copy to (m.TempFile) for ;
	    BETWEEN(RECNO(), 2, RECCOUNT() - 1) and ;
        (&WhatFor)
	select( m.work )
	append from (m.TempFile)

** create list of distinct parent definitions
	create cursor (m.TempFile) (Parent C(254))
	select( m.FormAlias )
	SCAN for BETWEEN(RECNO(), 2, RECCOUNT()-1) ;
         and not (&WhatFor)
		insert into (m.TempFile) (parent) ;
		      value (UPPER(xTRIM(EVAL( ;
                     m.FormAlias +".PARENT"))))
	ENDS
	select( m.TempFile )

	select * from (m.TempFile) ;
             into cursor (m.UniqParent) ;
	         distinct noconsole
	use in (m.TempFile)

	parent = "?"
	select( m.FormAlias )
	set filter to ;
       (UPPER(ALLTRIM(parent)) == m.parent) and ;
	    BETWEEN(RECNO(), 2, RECCOUNT() - 1) and ;
        not (&WhatFor)

	ParentFilt = ;
        "((ATC('Line', BaseClass) > 0) or " + ;
		"(ATC('Shape', BaseClass) > 0)"
	if empty( m.p2label )
		ParentFilt = m.ParentFilt + ;
		    " or (ATC('Label', BaseClass) > 0))"
	else
		ParentFilt = m.ParentFilt + ")"
	endif

** Sort object order only inside each parent.
** Loop of parents
	select( m.UniqParent )
	SCAN
		parent = UPPER(ALLTRIM(parent))
		select( m.FormAlias )
		dime aList(RECCOUNT(), 2)
		copy to	(m.TempFile) for &ParentFilt
		select( m.work )
		append from (m.TempFile)

		select( m.FormAlias )
		n = 0
		SCAN for not &ParentFilt
			j = VAL(get1prop(,"TabIndex"))
			if empty( m.j )
				copy NEXT 1 to (m.TempFile)
				select( m.work )
				append from (m.TempFile)
			else
				n = m.n + 1
				aList(m.n, 1) = m.j
				aList(m.n, 2) = RECNO()
			endif
		ENDS
		if m.n > 0
			dime aList(m.n, 2)
			ASORT( aList )
			for j = 1 to ALEN(aList, 1)
				select( m.FormAlias )
				goto (aList(m.j, 2))
				copy NEXT 1 to (m.TempFile)
				select( m.work )
				append from (m.TempFile)
			endfor
		endif
	ENDS
	use in (m.UniqParent)
	select( m.FormAlias )
	set filter to

** Re-assemble the new form, taking care 
** of the last record
	if RECCOUNT(m.FormAlias) > 1
		select( m.FormAlias )
		goto (RECCOUNT())
		copy NEXT 1 to (m.TempFile)
		select( m.work )
		append from (m.TempFile)
		use in (m.work)
		select( m.FormAlias )
		ZAP
		append from (m.work)
	endif

	if used(m.work)
		use in (m.work)
	endif
	select( m.FormAlias )
	reindex
	use
	AnyDone = .t.
endfor

** clean up temporary stuff
if used( m.FormAlias )
	use in (m.FormAlias)
endif
if used(m.work)
	use in (m.work)
endif
Erase(m.work + ".DBF")
Erase(m.work + ".FPT")
Erase(m.TempFile + ".DBF")
Erase(m.TempFile + ".FPT")

** restore SET PROC settings
set proc to
for i = 1 to ALEN(aProcs)
	if not empty(aProcs( m.i ))
		set proc to (aProcs( m.i )) additive
	endif
endfor

set decimal to m.SaveDecim
set escape off
if empty( m.AnyDone )
	wait window ;
        "<<< NO FORM CONVERTED >>>" time 5
endif

** restore environment
select( m.SaveArea )
on escape &OnEscape
set escape &SetEscape
set talk on &SaveTalk
wait clear
return
