******************************************************
*
*       PROGRAM : F_INTEL.PRG
*        AUTHOR : DOMINIC WHITE
*          DATE : 8/1/03
*
*        NOTICE : Clay Finlay Inc.
*                 200 Park Avenue
*                 New York NY 10166
*
*  CURRENT VERS :2.0 -- GLOBAL
*  VERS HISTORY :
*               :
*   DESCRIPTION :ALLOWS USER TO CREATE/ALTER/MANAGE CUSTOM FUNCTIONS/SCRIPTS
*               :THROUGH FOXPRO'S INTELLISENSE UTILITY
*
******************************************************
CLOSE DATABASES
CLEAR

cDeleted = SET("Deleted")
SET DELETED ON

*FIRST VERIFY FILES ARE IN PLACE
lErr = .F.
lFox = _FOXCODE
lCs  = _CODESENSE
IF EMPTY(lFox) OR EMPTY(lCs)
   DO CASE
      CASE EMPTY(lFox) AND EMPTY(lCs)
         MESSAGEBOX("Your system is missing both FOXCODE.dbf and the CODESENSE procedure in FOXCODE.app",48,"File Error!")
      CASE EMPTY(lFox)
         MESSAGEBOX("Your system is missing the FOXCODE.dbf file",48,"File Error!")
      OTHERWISE
         MESSAGEBOX("Your system is missing the CODESENSE procedure in FOXCODE.app",48,"File Error!")
   ENDCASE
   RETURN
ENDIF
=close_file('FOXCODE')

*txt file stores dir info
IF !FILE(HOME(7)+'D_LOCAT.TXT')
   nHandle = FCREATE(HOME(7)+'D_LOCAT.TXT')
   cStr = HOME(7)
   =FWRITE(nHandle,cStr)
   =FCLOSE(nHandle)
ELSE
   nHandle = FOPEN(HOME(7)+'D_LOCAT.TXT')
   nSize = FSEEK(nHandle, 0, 2)
   =FSEEK(nHandle, 0, 0)
   cStr = FREAD(nHandle,nSize)
   =FCLOSE(nHandle)   
ENDIF

IF !FILE(cStr+'MENUITEMS.DBF')
   CREATE TABLE(cStr+'MENUITEMS') (KEY C(25), KEY2 C(15), MENUITEM C(65), MENUTIP M)
   USE
ENDIF
IF !FILE(cStr+'CUSTOM_SCRIPT.DBF')
   CREATE TABLE(cStr+'CUSTOM_SCRIPT') (TYPE C(1),ABBREV C(24),EXPANDED C(26),CMD C(15),TIP M,DATA M,TIMESTAMP T,SOURCE M,UNIQUEID C(10),USER M)
   cDMenu = ''
   cDMenu = get_d_menu()
   SCATTER MEMVAR MEMO BLANK 
   m.Type = 'S'
   m.Abbrev = 'dommenu'
   m.Data = cDMenu
   m.Save = .t.
   m.Timestamp = DATETIME()
   m.Source = 'DOMI'
   INSERT INTO custom_script FROM MEMVAR 
   USE
   USE _FOXCODE
   INSERT INTO FOXCODE FROM MEMVAR
   USE
ENDIF
IF !FILE(cStr+'LIST_SCRIPT.DBF')
   CREATE TABLE(cStr+'LIST_SCRIPT') (TYPE C(1),EXPANDED C(30), INFO M)
   USE
ENDIF

*open files including the user's _foxcode file...make sure not home(0)!!
IF .t.  &&!lCreate
   USE cStr+'menuitems' IN 0
   USE cStr+'custom_script' IN 0
   USE cStr+'list_script' IN 0
ENDIF
USE (_FOXCODE) IN 0

*SET UP VARIABLES -- should use INCLUDE 
cMainDir     = cStr  && location of shared directory -- home(7) is default
nCustomDef   = 0  && STATUS OF lAllowCustomDefScripts IN CUSTOMPEMS
nList1Pos    = 1  && POSITION OF LIST1 ARRAY
nList2Pos    = 1  && POSITION OF LIST2 ARRAY
nForS        = 1  && USER LOOKING AT FUNCTIONS OR SCRIPTS
nAorR        = 1  && USER ADDING OR REMOVING FUNCTION/SCRIPT
nAdRemPos    = 1  && POSITION OF M1_ADREM ARRAY (COMBOBOX1)
nSFunctPos   = 1  && POSITION OF M1_SFUNCTAR -- NEW/DELE/MODIFY FUNCTIONS
cMainTip     = '' && MAIN TIP FOR UNDERLYING FUNCTION
cFunctName   = '' && NAME OF NEW/SELECTED FUNCTION
nPlacement   = 0  && PLACEMENT OF TIP/LIST WITHIN MAIN PARAMETER LIST
cKey         = '' && USED FOR M1_MENU ARRAY AND MENUITMES TABLE
nTipPos      = 1  && Position within Tip array
nListPos     = 1  && Position within List array
nLTipPos     = 1  && Position within Menu Tip array
cEditM       = '' && Menu Tip
cAbbrev      = '' && Users Abbreviation for the function
cEditT       = '' && Sub Tip
nList3Pos    = 1  && Position within the "since modified" array

DIMENSION aList1[1]  && DISPLAYS THE SCRIPTS IN PLACE
SELECT ALLTRIM(EXPANDED) FROM FOXCODE WHERE ATC('DOMI',SOURCE)<>0 AND TYPE = 'F' INTO ARRAY aList1

DIMENSION aList2[1]  && DISPLAYS THE REMAINING AVAILABLE SCRIPTS
SELECT ALLTRIM(EXPANDED) FROM CUSTOM_SCRIPT WHERE ATC('DOMI',SOURCE)<>0 AND TYPE = 'F' AND ASCAN(aList1,ALLTRIM(EXPANDED))=0 INTO ARRAY aList2

DIMENSION aList3[1]  && DISPLAYS THE REMAINING AVAILABLE SCRIPTS
aList3 = ''
DIMENSION aAdRem[1]
aAdRem = ''
DIMENSION aMemo[1]
aMemo = ''
DIMENSION aMemoDel[1]
aMemoDel = ''
DIMENSION aSFunct[1]  && ARRAY OF FUNCTIONS TO ADD/DELE MODIFY
aSFunct[1] = 'NEW'
DIMENSION aTip[1,3]
aTip = ''
DIMENSION aList[1,2]
aList = ''
DIMENSION aLTip[1,2]
aLTip = ''
DIMENSION aMenu[1,3]
aMenu = ''


cDef = DEFSCRIPTSTATUS('C')
IF cDef = 'T'
   nCustomDef = 1
ENDIF

DO FORM WHITE

=close_file()
SET DELETED &cDeleted
RETURN



PROCEDURE DEFSCRIPTSTATUS
   PARAMETERS cAct
   PRIVATE cAct
   LOCAL cRet, cText
   LOCAL ARRAY aTemp[1]
   SELECT FOXCODE
   LOCATE FOR ALLTRIM(ABBREV) = 'CustomPEMs'
   =ALINES(aTemp,DATA)  && 1 COLUMN ARRAY
   M9ROW = ASCAN(aTemp,'lAllowCustomDefScripts')
   DO CASE
      CASE cAct = 'C'
         cRet = SUBSTR(RIGHT(aTemp[M9ROW],2),1,1)
      OTHERWISE
         aTemp[M9ROW] = LEFT(aTemp[M9ROW],LEN(aTemp[M9ROW])-3) + '.'+cAct+'.'
         cText = ''
         FOR M9A = 1 TO ALEN(aTemp)
            cText = cText + aTemp[M9A] + IIF(M9A = ALEN(aTemp), '', CHR(13))
         ENDFOR
         REPLACE FOXCODE.DATA WITH cText
         cRet = .T.
   ENDCASE
   RETURN cRet

PROCEDURE close_file
   PARAMETER cFileNam
   PRIVATE cFileNam
   IF PARAMETERS() = 0
      CLOSE DATA
   ELSE
      IF USED('&cFileNam')
         SELECT(cFileNam)
         USE
      ENDIF
   ENDIF

PROCEDURE get_d_menu
   LOCAL cText
   cText = ''
   TEXT TO cText NOSHOW 
LPARAMETER oFoxcode
LOCAL eRetVal, loFoxCodeLoader, nHandle, nSize, cStr
IF FILE(_CODESENSE)
   IF FILE(HOME(7)+'D_LOCAT.TXT')
      nHandle = FOPEN(HOME(7)+'D_LOCAT.TXT')
      nSize = FSEEK(nHandle, 0, 2)
      =FSEEK(nHandle, 0, 0)
      cStr = FREAD(nHandle,nSize)
      =FCLOSE(nHandle)
   ELSE
      RETURN
   ENDIF   
   SET DELETED ON
   SET PROCEDURE TO (_CODESENSE) ADDITIVE
   loFoxCodeLoader = CreateObject("FoxCodeLoader")
   eRetVal = loFoxCodeLoader.Start(m.oFoxCode)
   loFoxCodeLoader = NULL
   IF ATC(_CODESENSE,SET("PROC"))#0
      RELEASE PROCEDURE (_CODESENSE)
   ENDIF
   RETURN m.eRetVal
ENDIF

DEFINE CLASS FoxCodeLoader as FoxCodeScript
   PROCEDURE Main()
      LOCAL lnParmNum,lcLookupCode,lcItem,lnPos,lnLines,i
      LOCAL aTmpData, aParmData, lcType
      lcItem = THIS.oFoxcode.menuitem
      DIMENSION aTmpData[1]
      DIMENSION aParmData[1,3]
      STORE "" TO aParmData
      lnLines = ALINES(aTmpData,ALLTRIM(THIS.oFoxCode.data))
      FOR i = 1 TO lnLines
         IF ISDIGIT(aTmpData[m.i])
            lnParmNum = VAL(ALLTRIM(GETWORDNUM(aTmpData[m.i],1,",")))
            lcLookupCode = ALLTRIM(GETWORDNUM(aTmpData[m.i],2,","))
            lcType = ALLTRIM(GETWORDNUM(aTmpData[m.i],3,","))
            iF !EMPTY(lcLookupCode)
               IF !EMPTY(aParmData)
                  DIMENSION aParmData[ALEN(aParmData,1)+1,3]
               ENDIF
               aParmData[ALEN(aParmData,1),1] = lnParmNum
               aParmData[ALEN(aParmData,1),2] = lcLookupCode
               aParmData[ALEN(aParmData,1),3] = lcType
            ENDIF
         ENDIF
      ENDFOR
      lnPos = ASCAN(aParmData,THIS.oFoxCode.paramnum+1,-1,-1,1)
      IF lnPos>0
         IF aParmData[lnPos+2]="T"
            * Display parameter tip
            THIS.GetCmdTip(aParmData[lnPos+1],"F")
         ELSE 
            * Display parameter menu
            IF THIS.GETLIST(aParmData[lnPos+1])
               THIS.oFoxCode.valuetype='L'
               RETURN ALLTRIM( THIS.OFOXCODE.EXPANDED )
            ENDIF
         ENDIF
         RETURN ""
      ENDIF
      THIS.oFoxCode.valuetype='V'
      RETURN THIS.AdjustCase()
   ENDPROC

   PROCEDURE GETLIST( tcKEY )
      LOCAL llRETVAL
      LOCAL ARRAY laTEMP[1]
      ***GET MATCHING RECORDS FROM THE MENU LIST
      IF USED('MENUITEMS')
         SELECT('MENUITEMS')
         USE
      ENDIF
      SELECT 0
      SET DELETED ON
      USE cStr+"MENUITEMS"
      STORE 0 TO _TALLY
      SELECT ALLTRIM(MENUITEM),menutip FROM menuitems INTO ARRAY laTEMP WHERE ALLTRIM(key) = UPPER(tcKEY) ORDER BY KEY2
      ***SET THE RETURN VALUE AND CLOSE THE TABLE
      STORE (_TALLY > 0) TO llRETVAL
      USE IN MENUITEMS
      IF llRETVAL
         ***POPULATE THE FOXCODE ITEM ARRAY
         DIMENSION THIS.OFOXCODE.ITEMS[_TALLY, 2]
         ACOPY( laTEMP, THIS.OFOXCODE.ITEMS )
      ENDIF
      RETURN llRETVAL
   ENDPROC
ENDDEFINE
ENDTEXT

PROCEDURE change_intel_dir
   LOCAL cTempStr
   cTempStr = GETDIR(cStr,'Choose New Directory','Select a new directory for the shared files')
   IF !EMPTY(cTempStr)
      IF FILE(cTempStr+'MENUITEMS.dbf') OR FILE(cTempStr+'LIST_SCRIPT.dbf');
         OR FILE(cTempStr+'CUSTOM_SCRIPT.dbf')
         *make sure file with same name not already there
         =MESSAGEBOX("There is a file name conflict",48,"File Conflict")
         RETURN
      ENDIF 
      *USER CHANGED THE DIR, COPY ALL FILES
      =close_file('MENUITEMS')
      COPY FILE cSTR+'MENUITEMS.*' TO cTempStr+'MENUITEMS.*'
      =close_file('LIST_SCRIPT')
      COPY FILE cSTR+'LIST_SCRIPT.*' TO cTempStr+'LIST_SCRIPT.*'
      =close_file('CUSTOM_SCRIPT')
      COPY FILE cSTR+'CUSTOM_SCRIPT.*' TO cTempStr+'CUSTOM_SCRIPT.*'
      
      *DELE OLD FILES
      DELETE FILE cSTR+'MENUITEMS.*'
      DELETE FILE cSTR+'LIST_SCRIPT.*'
      DELETE FILE cSTR+'CUSTOM_SCRIPT.*'
      
      *OPEN NEW FILES
      USE cTempStr+'MENUITEMS' IN 0
      USE cTempStr+'LIST_SCRIPT' IN 0
      USE cTempStr+'CUSTOM_SCRIPT' IN 0
      
      *SET PATH
      cStr = cTempStr
      cMainDir = cStr
      
      *RECORD PATH TO TEMP_FILE
      DELETE FILE HOME(7)+'D_LOCAT.TXT'
      nHandle = FCREATE(HOME(7)+'D_LOCAT.TXT')
      =FWRITE(nHandle,cStr)
      =FCLOSE(nHandle)   
         
   ENDIF
   RETURN