**********************************************************************
* Program....: DoSets
* Compiler...: Visual FoxPro 06.00.8492.00 for Windows
* Abstract...: Quickie function to set up the environment
* ...........: Called from BeforeOPenTables method of DE so forms with private
* ...........: datasession have everything set up properly before opening views
**********************************************************************
FUNCTION DoSets

SET SYSFORMATS ON
SET SAFETY OFF
SET MEMOWIDTH TO 120
SET TALK OFF
SET CENTURY ON
SET CENTURY TO 19 ROLLOVER 30
SET MULTILOCKS ON               && For table buffering
SET DELETED ON
SET EXCLUSIVE OFF
SET NOTIFY OFF
SET BELL OFF
SET NEAR OFF
SET EXACT OFF
SET INTENSITY OFF
SET CONFIRM ON
SET STATUS BAR OFF
SET NULLDISPLAY TO 'None'
ENDFUNC

**********************************************************************
* Program....: GetKey
* Compiler...: Visual FoxPro 06.00.8492.00 for Windows
* Abstract...: Get a unique PK value for tables or updateable cursors not in the DBC
* ...........: (therefore can't use Stored Procedure NewID for this)
**********************************************************************
FUNCTION GetKey
LPARAMETER lcTableName
LOCAL lnRetVal, lnOldRepr

lnRetVal = 0

IF NOT USED( "Setup" )
   USE SetUp IN 0
ENDIF
SELECT SetUp
SET ORDER TO TableName
CURSORSETPROP( "Buffering", 1 )		&& set buffering off
SEEK UPPER(lcTableName)
IF NOT FOUND()
   INSERT INTO SetUp ( TableName, Value) VALUES ( lcTableName, 1 )
   lnRetVal = 1
ELSE        
   lnOldRepr = SET( "REPR" )
   SET REPROCESS TO 5 SECONDS
   IF RLOCK()
     ** Check for valid integer value
      IF TYPE( 'SetUp.Value' ) = "N"
         IF SetUp.Value < 2147483646
            lnRetVal = SetUp.Value + 1            
            REPLACE Value WITH lnRetVal
         ENDIF   
      ENDIF 
   ENDIF
   UNLOCK
   SET REPROCESS TO ( lnOldRepr )
ENDIF
USE

RETURN lnRetVal
ENDFUNC

